/*
 * PCSound Test (SFX from Project Spitfire)
 */

#include <stdlib.h>
#include <signal.h>
#include "SDL.h"
#include "pcsound.h"

#define	S_FIRE1		0
#define	S_FIRE2		1
#define	S_FIRE3		2
#define	S_FIRE4		3
#define	S_FIRE5		4

#define	S_PLAYERFIRE	5
#define	S_BOOM		6
#define	S_BOOM2		7
#define	S_BLOPP		8
#define	S_GAMEOVER	9
#define	S_BOMB		10
#define	S_STARTPLAY	11
#define	S_POWERUP	12
#define	S_PING		13

#define	S_LAST		13

int	sfx[S_LAST+1];


int pas_random(int range)
{
	return rand() % range;
}

/*
 * Create some sound effect data...
 */
void InitSoundFx()
{
	int i;

	PCS_StartProgramming();

	sfx[S_FIRE1]=PCS_Current();
	PCS_Push(2);
	for( i=1; i<=6; ++i )
	{
		PCS_Push(250-i*30);
		PCS_Push(2);
	}
	PCS_Push(0);

	sfx[S_FIRE2]=PCS_Current();
	PCS_Push(2);
	for( i=1; i<=6; ++i )
	{
		PCS_Push(270-i*35);
		PCS_Push(2);
	}
	PCS_Push(0);

	sfx[S_FIRE3]=PCS_Current();
	PCS_Push(2);
	for( i=1; i<=6; ++i )
	{
		PCS_Push(320-i*38);
		PCS_Push(2);
	}
	PCS_Push(0);

	sfx[S_FIRE4]=PCS_Current();
	PCS_Push(2);
	for( i=1; i<=6; ++i )
	{
		PCS_Push(380-i*45);
		PCS_Push(2);
	}
	PCS_Push(0);

	sfx[S_FIRE5]=PCS_Current();
	PCS_Push(2);
	PCS_Push(450);
	PCS_Push(2);
	PCS_Push(250);
	PCS_Push(2);
	PCS_Push(300);
	PCS_Push(2);
	PCS_Push(200);
	PCS_Push(2);
	for( i=1; i<=4; ++i )
	{
		PCS_Push(100-i*8);
		PCS_Push(2);
	}
        PCS_Push(0);

	sfx[S_BOOM]=PCS_Current();
	PCS_Push(2);
	for( i=1; i<=15; ++i )
	{
		PCS_Push(140-i*5+pas_random(50));
        	PCS_Push(2);
        }
	PCS_Push(0);

	sfx[S_BOOM2]=PCS_Current();
	PCS_Push(2);
	for( i=1; i<=40; ++i )
	{
		PCS_Push(225-i*4+pas_random(60));
		PCS_Push(2);
        }
	PCS_Push(0);

	sfx[S_BLOPP]=PCS_Current();
        PCS_Push(2);
	for( i=1; i<=3; ++i )
	{
		PCS_Push(250-i*50);
	}
	PCS_Push(0);

        sfx[S_PLAYERFIRE]=PCS_Current();
	PCS_Push(2);
	for( i=1; i<=5; ++i )
	{
		PCS_Push(300-i*20);
        	PCS_Push(165-i*20);
		PCS_Push(2);
	}
	PCS_Push(0);

	sfx[S_GAMEOVER]=PCS_Current();
	PCS_Push(2);
	for( i=1; i<=30; ++i )
	{
		PCS_Push(670-i*20);
        	PCS_Push(2);
        }
	PCS_Push(0);

	sfx[S_BOMB]=PCS_Current();
	PCS_Push(2);
	for( i=1; i<=12; ++i )
	{
        	PCS_Push(7000-i*300);
                PCS_Push(70+pas_random(200-6*i));
        }
	PCS_Push(0);

	sfx[S_STARTPLAY]=PCS_Current();
	PCS_Push(2);
	for( i=1; i<=60; ++i )
	{
		PCS_Push(65+i*4);
		PCS_Push(2);
	}
	PCS_Push(0);

	sfx[S_POWERUP]=PCS_Current();
	PCS_Push(2);
	PCS_Push(311);
	PCS_Push(311);
	PCS_Push(311);
	PCS_Push(440);
	PCS_Push(440);
	PCS_Push(440);
	PCS_Push(622);
	PCS_Push(622);
	PCS_Push(622);
		PCS_Push(311);
		PCS_Push(311);
		PCS_Push(1);
		PCS_Push(440);
		PCS_Push(440);
		PCS_Push(1);
		PCS_Push(622);
		PCS_Push(622);
		PCS_Push(1);
			PCS_Push(311);
			PCS_Push(1);
			PCS_Push(1);
			PCS_Push(440);
			PCS_Push(1);
			PCS_Push(1);
			PCS_Push(622);
	PCS_Push(0);

	sfx[S_PING]=PCS_Current();
	PCS_Push(2);
	PCS_Push(700);
	PCS_Push(2500);
	PCS_Push(0);

	PCS_EndProgramming();
}


void breakhandler(int a)
{
	PCS_Close();
	SDL_Quit();
	exit(1);
}

int main(int argc, char *argv[])
{
	if(SDL_Init(0) < 0)
		exit(1);

	atexit(SDL_Quit);
	signal(SIGTERM, breakhandler);
	signal(SIGINT, breakhandler);
	
	if(PCS_Init(1) < 0)
		exit(1);

	InitSoundFx();

	while(1)
	{
		PCS_Start(sfx[rand() % (S_LAST+1)]);
		SDL_Delay(100);
		SDL_Delay(rand() % 700);
	}

	PCS_Close();

	SDL_Quit();
}
